/* Shell script to start and stop the server */
/* Modification log                         *//*
2002.8   orca
   Tomcat 3.3.1 XNvg"tomcat.sh"Ƃɂč쐬
*/
options translate('ETmode')
True = 1; False = 0;

call getenv 'HOME'
if stream(home'/.tomcatrc', 'c', 'query exists') \== '' then
   '@call "'translate(home'/.tomcatrc"', '\', '/')

DEBUG_HOMEFIND = False

if getenv('TOMCAT_INSTALL') == '' then do
   parse source . . PRG /* symbolic link̂Ƃ͖ */
   PRG = FileSpec('Drive', PRG)FileSpec('Path', PRG)
   PRG = left(PRG, length(PRG) -1)

   TOMCAT_INSTALL_1 = PRG'/..'
   if DEBUG_HOMEFIND then
      say 'Guessing TOMCAT_INSTALL from tomcat.sh to 'TOMCAT_INSTALL_1
   if stream(TOMCAT_INSTALL_1'/lib/*', 'c', 'query exists') \== '' then do
      TOMCAT_INSTALL = TOMCAT_INSTALL_1
      if DEBUG_HOMEFIND then
         say 'Setting TOMCAT_INSTALL to 'TOMCAT_INSTALL
   end
end

if TOMCAT_INSTALL == '' then do
   if stream(HOME'/opt/tomcat/conf/*', 'c', 'query exists') \== '' then do
      TOMCAT_INSTALL = HOME'/opt/tomcat'
      if DEBUG_HOMEFIND then
         say 'Defaulting TOMCAT_INSTALL to 'TOMCAT_INSTALL
   end
   if stream('/opt/tomcat/conf/*', 'c', 'query exists') \== '' then do
      TOMCAT_INSTALL = '/opt/tomcat'
      if DEBUG_HOMEFIND then
         say 'Defaulting TOMCAT_INSTALL to 'TOMCAT_INSTALL
   end
end

if TOMCAT_INSTALL == '' then do
   say 'TOMCAT_INSTALL not set, you need to set it or install in a standard location'
   exit 1
end

call getenv 'TOMCAT_OPTS'
call getenv 'JSPC_OPTS'

if getenv('TOMCAT_HOME') == '' then do
   select
      when stream('./conf/*', 'c', 'query exists') \== '' then
         TOMCAT_HOME = '.'
      when stream('../conf/*', 'c', 'query exists') \== '' then
         TOMCAT_HOME = '..'
   otherwise
      TOMCAT_HOME = TOMCAT_INSTALL
   end
end

if getenv('JAVA_HOME') == '' then do
   call RxFuncAdd 'SysSearchPath', 'rexxutil', 'SysSearchPath'
   JAVA = SysSearchPath('PATH', 'java.exe')
   if JAVA == '' then do
      say 'Cannot find JAVA. Please set your PATH.'
      exit 1
   end
   JAVA_BINDIR = FileSpec('Drive', JAVA)FileSpec('Path', JAVA)
   JAVA_BINDIR = left(JAVA_BINDIR, length(JAVA_BINDIR) -1)

   saveddir = Directory()
   JAVA_HOME = Directory(JAVA_BINDIR'/..')
   if FileSpec('Name', JAVA_HOME) == 'jre' then
      JAVA_HOME = substr(JAVA_HOME, 1, length(JAVA_HOME) -4)
   call Directory saveddir
end

if getenv('JAVACMD') == '' then do
   JAVACMD = JAVA_HOME'/bin/java'
   if stream(JAVACMD'.*', 'c', 'query exists') == '' then
      JAVACMD = JAVA_HOME'/jre/bin/java'

   JAVACMD = translate(JAVACMD, '\', '/')
end

MAIN = 'org.apache.tomcat.startup.Main'
call value 'MAIN', MAIN, 'OS2ENVIRONMENT'

oldCP = getenv('CLASSPATH')
CLASSPATH = TOMCAT_INSTALL'/lib/tomcat.jar;'
call value 'CLASSPATH', CLASSPATH, 'OS2ENVIRONMENT'

TOMCAT_OPTS = TOMCAT_OPTS' -Djava.security.policy=='TOMCAT_HOME'/conf/tomcat.policy'

parse arg ARGS
call RxFuncAdd 'SysFileTree', 'rexxutil', 'SysFileTree'

select
   when word(ARGS, 1) == 'start_msg' then do
      parse var ARGS . ARGS
      say 'Starting Tomcat Servlet Engine'
   end

   when word(ARGS, 1) == 'stop_msg' then do
      parse var ARGS . ARGS
      say 'Stopping Tomcat Servlet Engine'
   end

   when word(ARGS, 1) == 'start' then do
      parse var ARGS . ARGS
      MAX_WAIT = 360
      WAIT = 0
      if word(ARGS, 1) == '-wait' then do
         parse var ARGS . ARGS
         WAIT = MAX_WAIT
      end

      if word(ARGS, 1) == '-noout' then do
         parse var ARGS . ARGS
         'start 'JAVACMD TOMCAT_OPTS' -Dtomcat.home='TOMCAT_HOME MAIN' start 'ARGS' >'TOMCAT_HOME'/logs/stdout.log 2>&1'
      end
      else do
         say 'Using classpath: 'CLASSPATH
         say 'Using JAVA_HOME: 'JAVA_HOME
         say 'Using TOMCAT_HOME: 'TOMCAT_HOME
         'start 'JAVACMD TOMCAT_OPTS' -Dtomcat.home='TOMCAT_HOME MAIN' start 'ARGS
      end

      JAVA_PID = pid/* ... */
   end

   when word(ARGS, 1) == 'stop' then do
      parse var ARGS . ARGS
      say 'Using classpath: 'CLASSPATH
      say 'Using JAVA_HOME: 'JAVA_HOME
      say 'Using TOMCAT_HOME: 'TOMCAT_HOME
      JAVACMD TOMCAT_OPTS' -Dtomcat.home='TOMCAT_HOME MAIN' stop 'ARGS

      if word(ARGS, 1) == '-force' then do
         parse var ARGS . ARGS
         /* ... */
      end
   end

   when word(ARGS, 1) == 'run' then do
      parse var ARGS . ARGS
      /* ȍ~ shiftIȂƂsꍇ _u邱ƂɂȂ͂ */
      if word(ARGS, 1) == 'enableAdmin' then
         JAVACMD TOMCAT_OPTS' -Dtomcat.home='TOMCAT_HOME MAIN' enableAdmin 'ARGS
      else if word(ARGS, 1) == '-enableAdmin' then
         JAVACMD TOMCAT_OPTS' -Dtomcat.home='TOMCAT_HOME MAIN' enableAdmin 'ARGS
      else do
         say 'Using classpath: 'CLASSPATH
         say 'Using JAVA_HOME: 'JAVA_HOME
         say 'Using TOMCAT_HOME: 'TOMCAT_HOME
         JAVACMD TOMCAT_OPTS' -Dtomcat.home='TOMCAT_HOME MAIN' start 'ARGS
      end
   end

   when word(ARGS, 1) == 'enableAdmin' then
      JAVACMD TOMCAT_OPTS' -Dtomcat.home='TOMCAT_HOME MAIN' enableAdmin 'ARGS

   when word(ARGS, 1) == 'estart' then
      JAVACMD TOMCAT_OPTS' -Dtomcat.home='TOMCAT_HOME MAIN' estart 'ARGS

   when word(ARGS, 1) == 'jspc' then do
      parse var ARGS . ARGS
      JAVACMD TOMCAT_OPTS' -Dtomcat.home='TOMCAT_HOME MAIN' jspc 'ARGS
   end

   when word(ARGS, 1) == 'jspcOrig' then do
      parse var ARGS . ARGS
      CLASSPATH = '.;'
      files = TOMCAT_HOME'/lib/container/*' TOMCAT_HOME'/lib/common/*'
      '@for %%f in ('translate(files, '\', '/')') do @echo %%f |rxqueue'
      do while queued() > 0
         parse pull i
         CLASSPATH = CLASSPATH ||strip(i)';'
      end
      CLASSPATH = CLASSPATH ||JAVA_HOME'/lib/tools.jar;'

      if stream(TOMCAT_HOME'/classes/*', 'c', 'query exists') \== '' then
         CLASSPATH = TOMCAT_HOME'/classes;'CLASSPATH

      if oldCP \== '' then
         CLASSPATH = CLASSPATH ||oldCP

      call SetLocal
       call Directory TOMCAT_HOME
       JAVACMD JSPC_OPTS' -Dtomcat.home='TOMCAT_HOME' org.apache.jasper.JspC 'ARGS
      call EndLocal
   end

   when word(ARGS, 1) == 'env' then do
      parse var ARGS . ARGS
      say 'Setting classpath to: 'CLASSPATH
      files = TOMCAT_HOME'/lib/*' TOMCAT_HOME'/lib/common/*' TOMCAT_HOME'/lib/container/*' TOMCAT_HOME'/lib/apps/*'
      '@for %%f in ('translate(files, '\', '/')') do @echo %%f |rxqueue'
      do while queued() > 0
         parse pull i
         CLASSPATH = CLASSPATH ||strip(i)';'
      end

      if stream(JAVA_HOME'/lib/tools.jar', 'c', 'query exists') \== '' then
         CLASSPATH = CLASSPATH ||JAVA_HOME'/lib/tools.jar;'

      if stream(TOMCAT_HOME'/classes/*', 'c', 'query exists') \== '' then
         CLASSPATH = TOMCAT_HOME'/classes;'CLASSPATH
      oldCP = CLASSPATH
   end

otherwise
   parse source . . PRG
   say 'Usage:'
   say PRG' (start|run|stop|enableAdmin|estart|env|jspc)'
   say '  start            - start tomcat in the background'
   say '  start -security  -   use a SecurityManager when starting'
   say '  start -noout     -   redirect stdout/stderr to $TOMCAT_HOME/logs/stdout.log'
   say '  start -wait      -   wait until tomcat is initialized before returning'
   say '  start -help      -   more options'
   say '                         (config, debug, estart, home, install, jkconf, sandbox)'
   say '  run              - start tomcat in the foreground'
   say '  run -security    -   use a SecurityManager when starting'
   say '  stop             - stop tomcat'
   say '  stop -force      -   stop tomcat with the ''kill'' command if necessary'
   say '  stop -help       -   more options'
   say '                         (ajpid, host, home, pass, port)'
   say '  enableAdmin      - Trust the admin web application,'
   say '                     i.e. rewrites conf/apps-admin.xml with trusted="true"'
   say '  estart           - Start Tomcat using the/your EmbededTomcat class which'
   say '                     uses a hardcoded set of modules'
   say '  env              - set CLASSPATH and TOMCAT_HOME env. variables'
   say '  jspc             - run jsp pre compiler'
   exit 0
end

if oldCP \== '' then
   call value 'CLASSPATH', oldCP, 'OS2ENVIRONMENT'
else
   call value 'CLASSPATH', '', 'OS2ENVIRONMENT'
exit


getenv:
   if symbol(arg(1)) == 'LIT' then
      call value arg(1), value(arg(1),, 'OS2ENVIRONMENT')
   return value(arg(1))

/**  End of Script  **/
